#include <def21161.h>

#define N 256

.section/dm seg_dmda;
.var sourceHost[N];
.var hostDest[N];

.var host_count = 0;

.section/pm seg_rth;

//EMUI:
	nop;
	nop;
	nop;
	nop;
	
//RSTI:
	nop;
	jump start;
	nop;
	nop;
	
.section/pm seg_pmco;
start:
	
	r0 = 1;
	dm(MSGR0) = r0;
	
	bit set mode2 FLG2O;
	
	ustat1 = dm(IOFLAG);
	bit set ustat1 FLG5O;
	dm(IOFLAG) = ustat1;
	
	bit clr ustat1 FLG5;
	dm(IOFLAG) = ustat1;
	
	bit clr flags FLG2;
	
	i1 = sourceHost;
	m0 = 1;
	r0 = 0x0;
	
	lcntr = N, do _init until lce;
	r2 = lshift r0 by 10;
	dm(i1,m0) = r2;
_init: r0 = r0 + 1;	
	
	bit set mode1 CBUFEN;
			
	b0 = hostDest;
	m0 = 1;
	l0 = @hostDest;
	
	i1 = 0x100006;
	m1 = 0;
	l1 = 0;
	
poll_msgr:
	r1 = dm(MSGR0);
	comp(r0,r1);
	if eq jump poll_msgr;
	
loophere:	
	
	LCNTR = N, do read_EPB1 until lce;
	r0 = dm(i1,m1);
	dm(i0,m0) = r0;	
		   nop;
read_EPB1: nop;

	i3 = sourceHost;
	i4 = hostDest;
	m3 = 1;
	
	LCNTR = N, do compare_data until lce;
	r0 = dm(i3,m3);
	r1 = dm(i4,m3);	
	comp (r0,r1);
	if eq jump compare_data;
	
	bit set flags FLG2;
	
	ustat1 = dm(IOFLAG);
	bit set ustat1 FLG5;
	dm(IOFLAG) = ustat1;	

compare_data: nop; nop; nop;
//loophere:
	r2 = dm(host_count);
	r2 = r2 + 1;
	dm(host_count) = r2;
	
	jump loophere;	

